Require Export List.

Class NonEmpty {A:Type} (l:list A) := {
  NonEmptyList :  l<> nil
}.

Instance consNonEmpty (A:Type) (a:A) (l:list A) : NonEmpty (a::l).
Proof.
  firstorder.
Qed.

Instance appNonEmptyRight (A:Type)  (l1 l2 :list A) {nvl: NonEmpty l2}  
                                    : NonEmpty (l1 ++ l2).
Proof.
constructor; destruct nvl.
destruct l1;simpl; auto; discriminate.
Qed.

Instance appNonEmptyLeft(A:Type)  (l1 l2 :list A) {nvl: NonEmpty l1} 
                                    : NonEmpty (l1 ++ l2).
Proof.
constructor; destruct nvl.
destruct l1;simpl; auto. discriminate.
Qed.

Instance mapNonEmpty(A B:Type)(f:A->B)(l:list A){nvl:NonEmpty l}:NonEmpty(map f l).
Proof.
constructor; destruct nvl.
destruct l;simpl; auto. discriminate.
Qed.

Program Definition strongNthClass  {A:Type}  (l :list A) {nvl: NonEmpty l} :A :=
  match l with 
    nil => _
    | h :: t => h
  end.
Next Obligation.
  destruct nvl as [foo]; contradict foo; reflexivity.
Qed.


Definition test1 :=(fun A (a:A) l => strongNthClass  (a::l)).
Definition test2 :=(fun A B (a:A) (f: A -> B) l => strongNthClass  (map f ((l++(a::nil))++l)) ).
(* Set Printing All.
Check (fun A (a:A) l => strongNthClass  (a::l)).

Check (fun A B (a:A) (f: A -> B) l => strongNthClass  (map f ((l++(a::nil))++l)) ).*)
(*  *)