Require Import Arith.
Require Import ZArith.
Require Import QArith.

Class Associative (A:Type) (op : A -> A ->A) :={
  associativity : forall a b c, op a (op b c) = op (op a b) c
}.

Class Addition (number : Type) :={
  add : number -> number -> number;
  add_assoc :> Associative number add 
}.

Infix " + " := add.

Instance add_associative  (number : Type) (add_instance : Addition number)  : Associative  number add. 
Proof.
  typeclasses eauto.
Qed.

Instance addition_nat : Addition nat:={add:=plus}.
Proof.
constructor.
auto with arith.
Qed.

Instance Addition_Z : Addition Z :={add:=Zplus}.
firstorder.
Qed.

(*  *)
